<?php
namespace bwdhsx_hero_section_namespace\Widgets;

use Elementor\Widget_Base;
use Elementor\Controls_Manager;

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class bwdhsx_hero_section_widgets7 extends Widget_Base {

    public function get_name() {
		return esc_html__( 'bwdhsx-hero-style7', BWDHSX_ROOT_AUTHOR );
	}

	public function get_title() {
		return esc_html__( 'Hero Style 7', BWDHSX_ROOT_AUTHOR );
	}

	public function get_icon() {
		return 'eicon-banner bwdhsx-herosections-image-icon';
	}

	public function get_categories() {
		return [ 'bwdhsx-hero-section-category' ];
	}

    protected function register_controls(){

		$this->start_controls_section(
			'bwdhsx_style7_content_section',
			[
				'label' => esc_html__( 'Content', BWDHSX_ROOT_AUTHOR ),
				'tab' => \Elementor\Controls_Manager::TAB_CONTENT,
			]
		);

		$this->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'bwdhsx_style7_background_img',
				'types' => [ 'classic', 'gradient' ],
				'selector' => '{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_single_slider',
			]
		);

		$this->add_control(
			'bwdhsx_style7_hr3',
			[
				'type' => \Elementor\Controls_Manager::DIVIDER,
			]
		);

		$this->add_control(
			'bwdhsx_style7_img',
			[
				'label' => esc_html__( 'Choose Image', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::MEDIA,
				'default' => [
					'url' => \Elementor\Utils::get_placeholder_image_src(),
				],
			]
		);

		$this->add_control(
			'bwdhsx_style7_hr1',
			[
				'type' => \Elementor\Controls_Manager::DIVIDER,
			]
		);

		$this->add_control(
			'bwdhsx_style7_button_title',
			[
				'label' => esc_html__( 'Button Title', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'default' => esc_html__( 'shop collection', BWDHSX_ROOT_AUTHOR ),
				'label_block' => true,
				'dynamic' => [
					'active' => true,
				],
			]
		);
		//button1 link
		$this->add_control(
			'bwdhsx_style7_button_link',
			[
				'label' => esc_html__( 'Button Link', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::URL,
				'placeholder' => esc_html__( 'https://example.com', BWDHSX_ROOT_AUTHOR ),
				'label_block' => true,
				'show_external' => true,
				'default' => [
                    'url' => 'https://bestwpdeveloper.com/',
                    'is_external' => true,
                    'nofollow' => true,
                ],
				'dynamic' => [
					'active' => true,
				],
			]
		);
		$this->add_control(
			'bwdhsx_style7_button_icon',
			[
				'label' => esc_html__( 'Button Icon', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::ICONS,
				'default' => [
					'value' => 'fas fa-chevron-right',
					'library' => 'fa-solid',
				],
				'recommended' => [
					'fa-solid' => [
						'circle',
						'dot-circle',
						'square-full',
					],
					'fa-regular' => [
						'circle',
						'dot-circle',
						'square-full',
					],
				],
			]
		);

		$this->add_control(
			'bwdhsx_style7_hr2',
			[
				'type' => \Elementor\Controls_Manager::DIVIDER,
			]
		);
		$this->add_control(
			'bwdhsx_style7_sub_title',
			[
				'label' => esc_html__( 'Sub Title', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'default' => esc_html__( 'BABY SHOP', BWDHSX_ROOT_AUTHOR ),
				'label_block' => true,
				'dynamic' => [
					'active' => true,
				],
			]
		);
		$this->add_control(
			'bwdhsx_style7_main_title',
			[
				'label' => esc_html__( 'Title', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'default' => esc_html__( 'New Collection Baby Girl', BWDHSX_ROOT_AUTHOR ),
				'label_block' => true,
				'dynamic' => [
					'active' => true,
				],
			]
		);

		$this->add_control(
			'bwdhsx_style7_description',
			[
				'label' => esc_html__( 'Description', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::WYSIWYG,
				'default' => esc_html__( 'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quis placerat arcu nibh sed placerat elementum. Urna eu et purus et mi sit rhoncus. Id nisl quis arcu nulla leo nulla cras justo consectetur adipiscing elit.', BWDHSX_ROOT_AUTHOR ),
			]
		);

		$this->end_controls_section();

		$this->start_controls_section(
			'bwdhsx_style7_common_section',
			[
				'label' => esc_html__( 'Common', BWDHSX_ROOT_AUTHOR ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);

		$this->add_responsive_control(
			'bwdhsx_style7_height',
			[
				'label' => esc_html__( 'Section Height', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%', 'em', 'rem', 'custom' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 5,
					],
					'%' => [
						'min' => 0,
						'max' => 100,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_single_slider' => 'height: {{SIZE}}{{UNIT}};',
				],
			]
		);

		$this->add_responsive_control(
			'bwdhsx_style7_content_width',
			[
				'label' => esc_html__( 'Text Content Width', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%', 'em', 'rem', 'custom' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 5,
					],
					'%' => [
						'min' => 0,
						'max' => 100,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_main-content' => 'width: {{SIZE}}{{UNIT}};',
				],
			]
		);

		$this->add_responsive_control(
			'bwdhsx_style7_image_content_width',
			[
				'label' => esc_html__( 'Image Content Width', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%', 'em', 'rem', 'custom' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 5,
					],
					'%' => [
						'min' => 0,
						'max' => 100,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_slider-image' => 'width: {{SIZE}}{{UNIT}};',
				],
			]
		);

		//vertical-alignment
		$this->add_responsive_control(
			'bwdhsx_style7_vertical_align',
			[
				'label' => esc_html__( 'Vertical Alignment', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::CHOOSE,
				'options' => [
					'start' => [
						'title' => esc_html__( 'Top', BWDHSX_ROOT_AUTHOR ),
						'icon' => 'eicon-v-align-top',
					],
					'center' => [
						'title' => esc_html__( 'Center', BWDHSX_ROOT_AUTHOR ),
						'icon' => 'eicon-v-align-middle',
					],
					'end' => [
						'title' => esc_html__( 'Bottom', BWDHSX_ROOT_AUTHOR ),
						'icon' => ' eicon-v-align-bottom',
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_single_slider .bwdhs_content-wrap' => 'align-items: {{VALUE}}',
				],
				'toggle' => true,
			]
		);

		$this->add_responsive_control(
			'bwdhsx_style7_alignment',
			[
				'label' => esc_html__( 'Text Alignment', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::CHOOSE,
				'options' => [
					'start' => [
						'title' => esc_html__( 'Left', BWDHSX_ROOT_AUTHOR ),
						'icon' => 'eicon-text-align-left',
					],
					'center' => [
						'title' => esc_html__( 'Center', BWDHSX_ROOT_AUTHOR ),
						'icon' => 'eicon-text-align-center',
					],
					'end' => [
						'title' => esc_html__( 'Right', BWDHSX_ROOT_AUTHOR ),
						'icon' => 'eicon-text-align-right',
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_main-content' => 'text-align: {{VALUE}}',
				],
			]
		);

		$this->add_responsive_control(
			'bwdhsx_style7_image_alignment',
			[
				'label' => esc_html__( 'Image Alignment', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::CHOOSE,
				'options' => [
					'start' => [
						'title' => esc_html__( 'Left', BWDHSX_ROOT_AUTHOR ),
						'icon' => 'eicon-text-align-left',
					],
					'center' => [
						'title' => esc_html__( 'Center', BWDHSX_ROOT_AUTHOR ),
						'icon' => 'eicon-text-align-center',
					],
					'end' => [
						'title' => esc_html__( 'Right', BWDHSX_ROOT_AUTHOR ),
						'icon' => 'eicon-text-align-right',
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_slider-image' => 'text-align: {{VALUE}}',
				],
			]
		);

		$this->add_control(
			'bwdhsx_style7_common_text_padding',
			[
				'label' => esc_html__( 'Text Content Padding', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em', 'rem', 'custom' ],
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_main-content' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		$this->add_control(
			'bwdhsx_style7_common_image_padding',
			[
				'label' => esc_html__( 'Image Content Padding', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em', 'rem', 'custom' ],
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_slider-image' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		$this->end_controls_section();

		$this->start_controls_section(
			'bwdhsx_style7_sub_title_section',
			[
				'label' => esc_html__( 'Sub Title', BWDHSX_ROOT_AUTHOR ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);

		$this->start_controls_tabs(
			'bwdhsx_style7_sub_title_style_tabs'
		);

		$this->start_controls_tab(
			'bwdhsx_style7_sub_title_style_normal_tab',
			[
				'label' => esc_html__( 'Normal', BWDHSX_ROOT_AUTHOR ),
			]
		);

		$this->add_control(
			'bwdhsx_style7_sub_title_color',
			[
				'label' => esc_html__( 'Text Color', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_sub-title' => 'color: {{VALUE}}',
				],
			]
		);

		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 'bwdhsx_style7_sub_title_typography',
				'selector' => '{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_sub-title',
			]
		);

		$this->add_control(
			'bwdhsx_style7_sub_title_margin',
			[
				'label' => esc_html__( 'Margin', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em', 'rem', 'custom' ],
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_sub-title' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_control(
			'bwdhsx_style7_sub_title_padding',
			[
				'label' => esc_html__( 'Padding', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em', 'rem', 'custom' ],
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_sub-title' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		$this->end_controls_tab();

		$this->start_controls_tab(
			'bwdhsx_style7_sub_title_style_hover_tab',
			[
				'label' => esc_html__( 'Hover', BWDHSX_ROOT_AUTHOR ),
			]
		);

		$this->add_control(
			'bwdhsx_style7_sub_title_color_hover',
			[
				'label' => esc_html__( 'Text Color', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_sub-title:hover' => 'color: {{VALUE}}',
				],
			]
		);

		$this->end_controls_tab();

		$this->end_controls_tabs();

		$this->end_controls_section();

		$this->start_controls_section(
			'bwdhsx_style7_title_section',
			[
				'label' => esc_html__( 'Title', BWDHSX_ROOT_AUTHOR ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);

		$this->start_controls_tabs(
			'bwdhsx_style7_title_style_tabs'
		);

		$this->start_controls_tab(
			'bwdhsx_style7_title_style_normal_tab',
			[
				'label' => esc_html__( 'Normal', BWDHSX_ROOT_AUTHOR ),
			]
		);

		$this->add_control(
			'bwdhsx_style7_title_color',
			[
				'label' => esc_html__( 'Text Color', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_main-title' => 'color: {{VALUE}}',
				],
			]
		);

		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 'bwdhsx_style7_title_typography',
				'selector' => '{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_main-title',
			]
		);

		$this->add_control(
			'bwdhsx_style7_title_margin',
			[
				'label' => esc_html__( 'Margin', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em', 'rem', 'custom' ],
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_main-title' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_control(
			'bwdhsx_style7_title_padding',
			[
				'label' => esc_html__( 'Padding', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em', 'rem', 'custom' ],
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_main-title' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		$this->end_controls_tab();

		$this->start_controls_tab(
			'bwdhsx_style7_title_style_hover_tab',
			[
				'label' => esc_html__( 'Hover', BWDHSX_ROOT_AUTHOR ),
			]
		);

		$this->add_control(
			'bwdhsx_style7_title_color_hover',
			[
				'label' => esc_html__( 'Text Color', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_main-title:hover' => 'color: {{VALUE}}',
				],
			]
		);

		$this->end_controls_tab();

		$this->end_controls_tabs();

		$this->end_controls_section();

		$this->start_controls_section(
			'bwdhsx_style7_desc_section',
			[
				'label' => esc_html__( 'Description', BWDHSX_ROOT_AUTHOR ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);

		$this->start_controls_tabs(
			'bwdhsx_style7_desc_style_tabs'
		);

		$this->start_controls_tab(
			'bwdhsx_style7_desc_style_normal_tab',
			[
				'label' => esc_html__( 'Normal', BWDHSX_ROOT_AUTHOR ),
			]
		);

		$this->add_control(
			'bwdhsx_style7_desc_color',
			[
				'label' => esc_html__( 'Text Color', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_sub-desce' => 'color: {{VALUE}}',
				],
			]
		);

		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 'bwdhsx_style7_desc_typography',
				'selector' => '{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_sub-desce',
			]
		);

		$this->add_control(
			'bwdhsx_style7_desc_margin',
			[
				'label' => esc_html__( 'Margin', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em', 'rem', 'custom' ],
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_sub-desce' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_control(
			'bwdhsx_style7_desc_padding',
			[
				'label' => esc_html__( 'Padding', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em', 'rem', 'custom' ],
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_sub-desce' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		$this->end_controls_tab();

		$this->start_controls_tab(
			'bwdhsx_style7_desc_style_hover_tab',
			[
				'label' => esc_html__( 'Hover', BWDHSX_ROOT_AUTHOR ),
			]
		);

		$this->add_control(
			'bwdhsx_style7_desc_color_hover',
			[
				'label' => esc_html__( 'Text Color', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_sub-desce:hover' => 'color: {{VALUE}}',
				],
			]
		);

		$this->end_controls_tab();

		$this->end_controls_tabs();

		$this->end_controls_section();

		$this->start_controls_section(
			'bwdhsx_style7_button_section',
			[
				'label' => esc_html__( 'Button', BWDHSX_ROOT_AUTHOR ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);

		$this->start_controls_tabs(
			'bwdhsx_style7_button_style_tabs'
		);

		$this->start_controls_tab(
			'bwdhsx_style7_button_style_normal_tab',
			[
				'label' => esc_html__( 'Normal', BWDHSX_ROOT_AUTHOR ),
			]
		);

		$this->add_control(
			'bwdhsx_style7_button_color',
			[
				'label' => esc_html__( 'Text Color', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_slide_button .bwdhs_link_btn.bttn_1' => 'color: {{VALUE}}',
				],
			]
		);

		$this->add_control(
			'bwdhsx_style7_button_bg_color',
			[
				'label' => esc_html__( 'Background Color', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_slide_button .bwdhs_link_btn.bttn_1' => 'background-color: {{VALUE}}',
				],
			]
		);

		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 'bwdhsx_style7_button_typography',
				'selector' => '{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_slide_button .bwdhs_link_btn.bttn_1',
			]
		);

		$this->add_control(
			'bwdhsx_style7_button_hr',
			[
				'type' => \Elementor\Controls_Manager::DIVIDER,
			]
		);
		$this->add_control(
			'bwdhsx_style7_button_more_options',
			[
				'label' => esc_html__( 'ICON', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::HEADING,
			]
		);

		$this->add_control(
			'bwdhsx_style7_button_icon_color',
			[
				'label' => esc_html__( 'Icon Color', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_slide_button .bwdhs_link_btn.bttn_1 i' => 'color: {{VALUE}}',
				],
			]
		);
		$this->add_responsive_control(
			'bwdhsx_style7_button_icon_size',
			[
				'label' => esc_html__( 'icon Size', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%', 'em', 'rem', 'custom' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 5,
					],
					'%' => [
						'min' => 0,
						'max' => 100,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_slide_button .bwdhs_link_btn.bttn_1 i' => 'font-size: {{SIZE}}{{UNIT}};',
				],
			]
		);
		$this->add_responsive_control(
			'bwdhsx_style7_button_icon_gap',
			[
				'label' => esc_html__( 'icon Gap', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%', 'em', 'rem', 'custom' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 5,
					],
					'%' => [
						'min' => 0,
						'max' => 100,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_slide_button .bwdhs_link_btn.bttn_1' => 'gap: {{SIZE}}{{UNIT}};',
				],
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'bwdhsx_style7_button_border',
				'selector' => '{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_slide_button .bwdhs_link_btn.bttn_1',
			]
		);
		$this->add_control(
			'bwdhsx_style7_button_border_radius',
			[
				'label' => esc_html__( 'Border Radius', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em', 'rem', 'custom' ],
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_slide_button .bwdhs_link_btn.bttn_1' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_control(
			'bwdhsx_style7_button_margin',
			[
				'label' => esc_html__( 'Margin', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em', 'rem', 'custom' ],
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_slide_button' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_control(
			'bwdhsx_style7_button_padding',
			[
				'label' => esc_html__( 'Padding', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em', 'rem', 'custom' ],
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_slide_button .bwdhs_link_btn.bttn_1' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		$this->end_controls_tab();

		$this->start_controls_tab(
			'bwdhsx_style7_button_style_hover_tab',
			[
				'label' => esc_html__( 'Hover', BWDHSX_ROOT_AUTHOR ),
			]
		);

		$this->add_control(
			'bwdhsx_style7_button_color_hover',
			[
				'label' => esc_html__( 'Text Color', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_slide_button .bwdhs_link_btn.bttn_1:hover' => 'color: {{VALUE}}',
				],
			]
		);

		$this->add_control(
			'bwdhsx_style7_button_bg_color_hover',
			[
				'label' => esc_html__( 'Background Color', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_slide_button .bwdhs_link_btn.bttn_1:hover' => 'background-color: {{VALUE}}',
				],
			]
		);

		$this->add_control(
			'bwdhsx_style7_button_icon_color_hover',
			[
				'label' => esc_html__( 'Icon Color', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_slide_button .bwdhs_link_btn.bttn_1:hover i' => 'color: {{VALUE}}',
				],
			]
		);

		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'bwdhsx_style7_button_border_hover',
				'selector' => '{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_slide_button .bwdhs_link_btn.bttn_1:hover',
			]
		);
		$this->add_control(
			'bwdhsx_style7_button_border_radius_hover',
			[
				'label' => esc_html__( 'Border Radius', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em', 'rem', 'custom' ],
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_slide_button .bwdhs_link_btn.bttn_1:hover' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		$this->end_controls_tab();

		$this->end_controls_tabs();

		$this->end_controls_section();

		$this->start_controls_section(
			'bwdhsx_style7_img_overlay_section',
			[
				'label' => esc_html__( 'Image Overlay', BWDHSX_ROOT_AUTHOR ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);

		$this->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'background',
				'types' => [ 'classic', 'gradient' ],
				'selector' => '{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_single_slider::before',
			]
		);

		$this->end_controls_section();

		$this->start_controls_section(
			'bwdhsx_style7_img_two_image_section',
			[
				'label' => esc_html__( 'Images', BWDHSX_ROOT_AUTHOR ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);

		$this->add_responsive_control(
			'bwdhsx_style7_img_width',
			[
				'label' => esc_html__( 'Image Width', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%', 'em', 'rem', 'custom' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 5,
					],
					'%' => [
						'min' => 0,
						'max' => 100,
					],
				],
				'default' => [
					'unit' => '%',
					'size' => 100,
				],
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_content-wrap .bwdhs_slider-image img' => 'max-width: {{SIZE}}{{UNIT}}!important;',
				],
			]
		);

		$this->start_controls_tabs(
			'bwdhsx_style7_image_1st_style_tabs'
		);

		$this->start_controls_tab(
			'bwdhsx_style7_image_1st_style_normal_tab',
			[
				'label' => esc_html__( 'Normal', BWDHSX_ROOT_AUTHOR ),
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'bwdhsx_style7_image_1st_border',
				'selector' => '{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_slider-image .banner-img-1',
			]
		);
		$this->add_control(
			'bwdhsx_style7_image_1st_border_radius',
			[
				'label' => esc_html__( 'Border Radius', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em', 'rem', 'custom' ],
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_slider-image .banner-img-1' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Box_Shadow::get_type(),
			[
				'name' => 'bwdhsx_style7_image_1st_box_shadow',
				'selector' => '{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_slider-image .banner-img-1',
			]
		);

		$this->end_controls_tab();

		$this->start_controls_tab(
			'bwdhsx_style7_image_1st_style_Hover_tab',
			[
				'label' => esc_html__( 'Hover', BWDHSX_ROOT_AUTHOR ),
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'bwdhsx_style7_image_1st_border_hover',
				'selector' => '{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_slider-image .banner-img-1:hover',
			]
		);
		$this->add_control(
			'bwdhsx_style7_image_1st_border_radius_hover',
			[
				'label' => esc_html__( 'Border Radius', BWDHSX_ROOT_AUTHOR ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em', 'rem', 'custom' ],
				'selectors' => [
					'{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_slider-image .banner-img-1:hover' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Box_Shadow::get_type(),
			[
				'name' => 'bwdhsx_style7_image_1st_box_shadow_hover',
				'selector' => '{{WRAPPER}} .bwdhs_sliderDesign_9 .bwdhs_slider-image .banner-img-1:hover',
			]
		);

		$this->end_controls_tab();

		$this->end_controls_tabs();

		$this->end_controls_section();

	}

	protected function render() {

        $settings = $this->get_settings_for_display();

		?>
		<div class="bwdhs_sliderDesign_9">
            <div class="bwdhs_single_slider">
                <div class="bwdhs_content-wrap">
                    <div class="bwdhs_slider-image">
                        <img src="<?php echo esc_url( $settings['bwdhsx_style7_img']['url'] );?>" alt="">
                    </div>
                    <div class="bwdhs_main-content">
                        <div class="bwdhs_sub-title"><?php echo esc_html($settings['bwdhsx_style7_sub_title'] );?></div>
                        <div class="bwdhs_main-title"><?php echo esc_html($settings['bwdhsx_style7_main_title'] );?></div>
                        <div class="bwdhs_sub-desce"><?php echo esc_html($settings['bwdhsx_style7_description'] );?></div>
                        <div class="bwdhs_slide_button">
                            <a class="bwdhs_link_btn bttn_1" href="<?php echo esc_url(isset($settings['bwdhsx_style7_button_link']['url']) ? $settings['bwdhsx_style7_button_link']['url'] : ''); ?>" <?php echo esc_attr(($settings['bwdhsx_style7_button_link']['is_external']) ? 'target="_blank"' : ''); ?>><?php echo esc_html($settings['bwdhsx_style7_button_title']); ?> <?php \Elementor\Icons_Manager::render_icon( $settings['bwdhsx_style7_button_icon'], [ 'aria-hidden' => 'true' ] ); ?></a>
                        </div>
                    </div>
                </div>
            </div>
        </div>
		<?php

    }

}